<script setup lang="ts">
import PlayButton from '~/assets/icons/play-button.vue';
import type { BaseHero } from '@/types/base';
import { ref } from 'vue';

defineProps<
  BaseHero & {
    config?: {
      videoUrl?: string;
      videoThumbnail?: string;
    };
  }
>();

const modalOpen = ref(false);
const openModal = () => {
  modalOpen.value = true;
};
const closeModal = () => {
  modalOpen.value = false;
};
</script>

<template>
  <section class="hero" :class="[{ 'has-image': image }, config?.theme]">
    <SlpContainer>
      <SlpRow class="wrapper">
        <SlpColumn class="content">
          <SlpTypography class="hero__title" variant="heading1-bold" tag="h1">
            {{ title }}
          </SlpTypography>
          <SlpTypography v-if="description" class="hero__description" variant="heading5" tag="p">{{
            description
          }}</SlpTypography>
          <div class="hero__buttons" role="group" aria-label="buttons">
            <SlpButton
              v-if="primaryButton"
              :href="primaryButton.config.href"
              variant="primary"
              class="button slp-mr-24"
              :data-ga-name="primaryButton.config.dataGaName"
              :data-ga-location="primaryButton.config.dataGaLocation"
            >
              {{ primaryButton.text }}
            </SlpButton>
            <SlpButton
              v-if="secondaryButton"
              :href="secondaryButton.config.href"
              variant="secondary"
              class="button"
              :data-ga-name="secondaryButton.config.dataGaName"
              :data-ga-location="secondaryButton.config.dataGaLocation"
            >
              {{ secondaryButton.text }}
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn v-if="image" cols="5" class="image" :class="image.config.theme">
          <img :src="image.config.src" :alt="image.altText" />
          <SlpButton v-if="config?.videoUrl" variant="ghost" class="video-spotlight-button" @click="openModal">
          </SlpButton>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <div v-if="config?.background === 'purple'" class="purple-background"></div>
    <Teleport v-if="config?.videoUrl" to="body">
      <CommonVideoModal :visible="modalOpen" @close="closeModal">
        <template #body>
          <CommonVideo :video-src="config?.videoUrl" class="video" :thumbnail-src="config?.videoThumbnail">
            <template #customPlayButton>
              <div class="vimeo-play-button">
                <PlayButton />
              </div>
            </template>
          </CommonVideo>
        </template>
      </CommonVideoModal>
    </Teleport>
  </section>
</template>

<style lang="scss" scoped>
.wrapper {
  gap: 32px;
}

.hero {
  padding: $spacing-64 0;
  position: relative;

  &.dark {
    background-color: $color-surface-700;
    color: $color-text-50;
  }

  &.has-image {
    .image {
      position: relative;
      img {
        width: 100%;
      }
    }

    .rounded {
      img {
        border-bottom-right-radius: 160px;
      }
    }
  }

  &:not(.has-image) {
    .content {
      width: 100%;
    }
  }

  .image img {
    max-width: 100%;
    height: auto;
    display: block;
    position: relative;
  }

  .content {
    padding-right: $spacing-64;

    @media (max-width: $breakpoint-sm) {
      padding-right: 0;
    }
  }

  &__description {
    margin-top: $spacing-24;
  }

  &__buttons {
    display: flex;
    gap: $spacing-4;
    margin-top: $spacing-24;

    @media (max-width: $breakpoint-sm) {
      flex-direction: column;
    }

    .button {
      @media (max-width: $breakpoint-sm) {
        justify-content: center;
        margin-top: $spacing-8;
      }
    }
  }
}

.purple-background {
  position: absolute;
  z-index: -1;
  right: 0;
  background-color: $color-surface-800;
  width: 35vw;
  height: 100%;
  top: 0;

  @media (max-width: $breakpoint-md) {
    display: none;
  }
}

.animated {
  opacity: 0;
  transform: translate3d(0, 50%, 0);
  animation: intro-reveal 0.9s ease-out 0.5s forwards;
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 50%, 0);
    opacity: 0;
  }
  to {
    transform: translate3d(0, 0, 0);
    opacity: 1;
  }
}

@media (prefers-reduced-motion: reduce) {
  .animated {
    animation: none;
    opacity: 1;
    transform: translate3d(0, 0, 0);
  }
}

.vimeo-play-button {
  position: absolute;
  left: 45%;
  top: 43%;
  background: $color-surface-50;
  transition: 0.15s;
  padding: $spacing-8 $spacing-24;
  color: $color-surface-700;
  border-radius: 4px;
  width: 88px;
  height: 56px;
  display: flex;
  justify-content: center;
  align-items: center;
  @media (max-width: $breakpoint-sm) {
    left: 40%;
    top: 38%;
    width: 70px;
    height: 46px;
  }
}

.video-spotlight-button {
  &::after {
    content: '';
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-35%, -50%);
    width: 0;
    height: 0;
    border-style: solid;
    border-width: 12px 0 12px 20px;
    border-color: transparent transparent transparent $color-surface-700;
    z-index: 1;
  }
  &::before {
    content: '';
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    width: 48px;
    height: 48px;
    background: $color-surface-50;
    border-radius: 50%;
    z-index: 0;
  }
}
</style>
